'
'$DYNAMIC
'
DEFINT A-Z
'
TYPE PALdata '(6 bytes)
 Red AS INTEGER
 Grn AS INTEGER
 Blu AS INTEGER
END TYPE
'
TYPE ENGdata '(46 bytes)
 TILwidth  AS INTEGER
 TILheight AS INTEGER
 TILxx     AS INTEGER
 TILyy     AS INTEGER
 TILhXL    AS INTEGER
 TILhXR    AS INTEGER
 TILvYT    AS INTEGER
 TILvYB    AS INTEGER
 MAPwidth  AS INTEGER
 MAPheight AS INTEGER
 MAPxx     AS INTEGER
 MAPyy     AS INTEGER
 MAPxxmax  AS INTEGER
 MAPyymax  AS INTEGER
 MAPlevels AS INTEGER
 MAPpixels AS LONG
 MAPcycles AS SINGLE
 CAMxx     AS INTEGER
 CAMyy     AS INTEGER
 CAMzx     AS INTEGER
 CAMzy     AS INTEGER
END TYPE
'
TYPE SYSdata '(12 bytes)
 vsync     AS INTEGER
 time      AS INTEGER
 collision AS INTEGER
 cycles    AS INTEGER
 blending  AS INTEGER
 weather   AS INTEGER
END TYPE
'
TYPE TILdata '(22 bytes)
 Kind  AS STRING * 16
 Walk  AS INTEGER
 Sink  AS INTEGER
 Cycle AS INTEGER
END TYPE
'
TYPE PLRdata '(58 bytes)
 xx        AS INTEGER
 yy        AS INTEGER
 Cycle     AS SINGLE
 frame     AS INTEGER
 pace      AS INTEGER
 Sink      AS INTEGER
 wide      AS INTEGER
 high      AS INTEGER
 direction AS INTEGER
 walking   AS INTEGER
 walkvY8   AS INTEGER
 walkvY2   AS INTEGER
 walkhX4   AS INTEGER
 walkhX6   AS INTEGER
 colx5     AS INTEGER
 coly5     AS INTEGER
 colX4     AS INTEGER
 colX6     AS INTEGER
 colY2     AS INTEGER
 colY8     AS INTEGER
 panvYT    AS INTEGER
 panvYB    AS INTEGER
 panhXL    AS INTEGER
 panhXR    AS INTEGER
 maxhXL    AS INTEGER
 maxhXR    AS INTEGER
 maxvYT    AS INTEGER
 maxvYB    AS INTEGER
END TYPE
'
DECLARE FUNCTION SCRcount (file$)
DECLARE FUNCTION FILlength& (file$)
'
DECLARE SUB BOXblend (xx1, yy1, xx2, yy2, SKINcolour)
DECLARE SUB SCRhandler (file$, SKINcolour, FONTcolour, skin$)
DECLARE SUB MENscript (file$, x1, y1, SKINcolour, FONTcolour, skin$)
DECLARE SUB MENhandler (Menu$)
DECLARE SUB SCRread (file$)
DECLARE SUB SCRshow (x1, y1, SKINcolour, FONTcolour, skin$)
DECLARE SUB GFXhandler ()
DECLARE SUB GFXshow ()
DECLARE SUB KEYget ()
DECLARE SUB KEYhandler ()
DECLARE SUB MAPcycler ()
DECLARE SUB MAPcollision ()
DECLARE SUB MAPhandler ()
DECLARE SUB MAPput (ARRAY(), LEVEL, skin$)
DECLARE SUB MAPget (ARRAY(), xx, yy, LEVEL)
DECLARE SUB MAPpan (direction)
DECLARE SUB PALload (file$, BLEND$)
DECLARE SUB PLRput ()
DECLARE SUB PUTcam (XXleft, YYtop, XXright, YYbottom)
DECLARE SUB PUTload (ARRAY(), file$)
DECLARE SUB PUTtext (ARRAY(), XXcenter, XXleft, YYtop, colour, TEXT$, skin$)
DECLARE SUB PUTtile (ARRAY(), XXleft, YYtop, frame, skin$)
DECLARE SUB DELsystem (seconds!)
 '
 DIM SHARED GFXxxLEFT, GFXyyTOP, GFXxxRIGHT, GFXyyBOTTOM
 DIM SHARED FONTwidth, FONTheight, FONTcolour
 DIM SHARED TEXTlength, TEXTubound, TEXTlbound
 DIM SHARED PUTcolour
 DIM SHARED redirect
 '
 DIM SHARED PAL(255) AS PALdata
 DIM SHARED SYS AS SYSdata
 DIM SHARED PLR AS PLRdata
 DIM SHARED ENG AS ENGdata
 '
 DIM SHARED GFX(32007)
 DIM SHARED BLEND(16447)
 DIM SHARED BOARD(127)
 DIM SHARED BLN&(255)
 DIM SHARED cpYY(8)
 DIM SHARED cpXX(8)
 '
 DIM SHARED FONT(0)
 DIM SHARED MAPS(0)
 DIM SHARED TILES(0)
 DIM SHARED PLAYER(0)
 DIM SHARED TEXT$(0)
 '
 PUTload MAPS(), "map.put"
 PUTload FONT(), "fnt.put"
 PUTload TILES(), "til.put"
 PUTload PLAYER(), "plr.put"
 '
 '::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 '::::::::::::::::::::: START OF USER-DEFINED VARIABLES ::::::::::::::::::::::
 '::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 '
 SYS.blending = NOT FALSE  'Blending On or Off.
 SYS.collision = NOT FALSE 'Collision On or Off.
 SYS.cycles = NOT FALSE    'Cycles On or Off.
 SYS.vsync = NOT FALSE     'Vsync On or Off.
 '
 ENG.TILxx = 21            'Tiles X, (# of horizontal tiles to scan from map).
 ENG.TILyy = 13            'Tiles Y, (# of Vertical tiles to scan from map).
 ENG.MAPlevels = 6         'MAP levels, (modify SUB GFXhandler too)!
 ENG.MAPcycles = .75       'MAP cycles, (animation in number of seconds).
 ENG.CAMxx = 0             'Camera X location, (horizonal left side).
 ENG.CAMyy = 0             'Camera Y location, (vertical top side).
 '
 PLR.xx = 152              'Player X location, (horizontal pixel cordinates).
 PLR.yy = 92               'Player Y location, (vertical pixels cordinates).
 PLR.direction = 2         'Player direction, (8-up, 2-down, 4-left, 6-right).
 PLR.pace = 1              'Player pace, (number of pixels per move).
 PLR.Cycle = .25           'Player cycle, (animation in number of seconds).
 PLR.panvYT = 76           'Player Y pan, (location to start 8-up panning).
 PLR.panvYB = 108          'Player Y pan, (location to start 2-down panning).
 PLR.panhXR = 168          'Player X pan, (location to start 6-right panning).
 PLR.panhXL = 136          'Player X pan, (location to start 4-left panning).
 '
 '...Collision Diagram...
 '    
 '       ;''''''''''''''; <--- Player Sprite... (default; 16 X 16 pixels).
 '       ;              ;
 '       ;              ;            -y
 '       ;              ;             |
 '       ;              ;      -x ----|---- +x  (Pixel cordinates).
 '       ;      8       ;             |
 '       ;;'''''|'''''';;            +y
 '       ;;4 ---5---  6;;
 '        ;     |      ; <--- Player Collision... (default; 14 X 7 pixels).
 '        ''''''2'''''''
 '
 PLR.colx5 = 7  'Collision x5, (offset +x, from top left of player sprite).
 PLR.coly5 = 15 'Collision y5, (offset +y, from top left of player sprite).
 '
 PLR.colX4 = -6 'Collision x4, (offset -x, from collision offsets x5, y5).
 PLR.colX6 = 7  'Collision x6, (offset +x, from collision offsets x5, y5).
 PLR.colY2 = 3  'Collision y2, (offset +y, from collision offsets x5, y5).
 PLR.colY8 = -3 'Collision y8, (offset -y, from collision offsets x5, y5).
 '
 '...Data for tiles of MAP()...
 '
 DIM SHARED TIL(250)  AS TILdata
 '
 FOR x = LBOUND(TIL) TO UBOUND(TIL)
  TIL(x).Kind = ""
  TIL(x).Walk = NOT FALSE
  TIL(x).Sink = FALSE
  TIL(x).Cycle = FALSE
 NEXT
 '
 TIL(1).Kind = "Lake"
 TIL(1).Walk = NOT FALSE
 TIL(1).Sink = 4
 TIL(1).Cycle = 9
 '
 TIL(2).Kind = "Grass"
 TIL(2).Walk = NOT FALSE
 TIL(2).Sink = FALSE
 TIL(2).Cycle = FALSE
 '
 TIL(6).Kind = "Tree"
 TIL(6).Walk = FALSE
 TIL(6).Sink = FALSE
 TIL(6).Cycle = FALSE
 '
 TIL(7).Kind = "Rock"
 TIL(7).Walk = NOT FALSE
 TIL(7).Sink = FALSE
 TIL(7).Cycle = FALSE
 '
 TIL(8).Kind = "Roof"
 TIL(8).Walk = NOT FALSE
 TIL(8).Sink = FALSE
 TIL(8).Cycle = FALSE
 '
 TIL(9).Kind = "Lake"
 TIL(9).Walk = NOT FALSE
 TIL(9).Sink = 4
 TIL(9).Cycle = 1
 '
 TIL(10).Kind = "Tree"
 TIL(10).Walk = NOT FALSE
 TIL(10).Sink = FALSE
 TIL(10).Cycle = FALSE
 '
 TIL(15).Kind = "Wall"
 TIL(15).Walk = FALSE
 TIL(15).Sink = FALSE
 TIL(15).Cycle = FALSE
 '
 TIL(20).Kind = "Shine"
 TIL(20).Walk = NOT FALSE
 TIL(20).Sink = FALSE
 TIL(20).Cycle = FALSE
 '
 TIL(21).Kind = "Lantern"
 TIL(21).Walk = NOT FALSE
 TIL(21).Sink = FALSE
 TIL(21).Cycle = FALSE
 '
 '::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 ':::::::::::::::::::::: END OF USER-DEFINED VARIABLES :::::::::::::::::::::::
 '::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 '
 ENG.TILwidth = TILES(0) \ 8
 ENG.TILheight = TILES(1)
 ENG.TILhXL = (320 - (ENG.TILxx * ENG.TILwidth)) \ 2
 ENG.TILvYT = (200 - (ENG.TILyy * ENG.TILheight)) \ 2
 ENG.TILhXR = ENG.TILhXL + (ENG.TILwidth * (ENG.TILxx - 1))
 ENG.TILvYB = ENG.TILvYT + (ENG.TILheight * (ENG.TILyy - 1))
 '
 ENG.MAPwidth = MAPS(0) \ 8
 ENG.MAPheight = MAPS(1)
 ENG.MAPpixels = ENG.MAPwidth * ENG.MAPheight
 ENG.MAPxxmax = ENG.MAPwidth - ENG.TILxx
 ENG.MAPyymax = ENG.MAPheight - ENG.TILyy
 ENG.MAPxx = ENG.CAMxx - 1
 ENG.MAPyy = ENG.CAMyy - 1
 '
 DIM SHARED MAP(1 TO ENG.MAPlevels, 1 TO (ENG.TILxx * ENG.TILyy))
 DIM SHARED Collide(1 TO ENG.MAPlevels, 0 TO 8) AS TILdata
 '
 hXL = ENG.TILhXL + ENG.TILwidth
 vYT = ENG.TILvYT + ENG.TILheight
 hXR = ENG.TILhXR - 1
 vYB = ENG.TILvYB - 1
 '
 PLR.wide = PLAYER(0) \ 8
 PLR.high = PLAYER(1)
 PLR.maxhXL = hXL
 PLR.maxvYT = vYT
 PLR.maxhXR = (hXR - ENG.TILwidth) + 1
 PLR.maxvYB = (vYB - ENG.TILheight) + 1
 '
 SCREEN 0: WIDTH 80: CLS
 '
 COLOR 1
 PRINT "Free Stack space: "; FRE(-2)
 PRINT "Free Array space: "; FRE(-1)
 PRINT "Free String space:"; FRE(0)
 PRINT
 COLOR 7
 PRINT "...Controls..."
 PRINT
 PRINT "[   ]"
 COLOR 4
 LOCATE 7, 2: PRINT "Esc"
 LOCATE 7, 8: PRINT "System Menu"
 PRINT
 COLOR 7
 PRINT "   [ ]"
 PRINT "[ ] + [ ]"
 PRINT "   [ ]"
 COLOR 2
 LOCATE 9, 5: PRINT "8"
 LOCATE 10, 2: PRINT "4"
 LOCATE 10, 8: PRINT "6"
 LOCATE 11, 5: PRINT "2"
 LOCATE 10, 12: PRINT "Player Movement"
 '
 DELsystem calibrate!
 '
 COLOR 7
 LOCATE 25, 1: PRINT "Press       to continue...";
 LOCATE 25, 7: PRINT "[";
 LOCATE 25, 11: PRINT "]";
 COLOR 15
 LOCATE 25, 8: PRINT "Spc";
 '
 DO: LOOP UNTIL INKEY$ = CHR$(32)
 '
 SCREEN 13
 '
 DEF SEG = &H0: POKE 1047, 0
 '
 FOR x = 0 TO 254
  BLN&(x + 1) = (BLN&(x) + (256 - x))
 NEXT
 '
 PALload "pal.pal", "bln.pal"
 '
 CLS : PRESET (160, 100), 0
 GFXseg& = 1 + VARSEG(GFX(0))
 DEF SEG : BSAVE "buffer.tmp", &H0, &HFA00
 DEF SEG = GFXseg&: BLOAD "buffer.tmp", 0
 KILL "buffer.tmp"
 FOR i = 8 TO 32007 - 1
  IF GFX(i) = &H7DA0 AND GFX(i + 1) = &HA000 THEN
   GFX(0) = ((i + 1) * 2) - 16
   GFX(1) = GFX(0) + 1
   GFX(4) = GFXseg& AND &HFF
   IF (GFXseg& AND &H8000) THEN
    GFX(5) = ((GFXseg& AND &HFF00) \ &HFF) + &H100
   ELSE
    GFX(5) = (GFXseg& AND &HFF00) \ &HFF
   END IF
   DEF SEG
   GFX(2) = PEEK(GFX(0))
   GFX(3) = PEEK(GFX(1))
   POKE GFX(0), GFX(4): POKE GFX(1), GFX(5)
   EXIT FOR
  END IF
 NEXT
 GFX(6) = 2560
 GFX(7) = 200
 '
 CLS            'Draw a frame around the camera's view.
 FOR x = 2 TO 5
  LINE (hXL - x, vYT - x)-(hXR + x, vYB + x), (31 - (x * 2)), B
 NEXT
 '
 PUTcam hXL, vYT, hXR, vYB
 '
 DO
  '
  KEYget
  KEYhandler
  MAPhandler
  MAPcollision
  MAPcycler
  GFXhandler
  GFXshow
  '
 LOOP
 '
 SYSTEM
 '

REM $STATIC
SUB BOXblend (xx1, yy1, xx2, yy2, SKINcolour)
 '
 IF xx2 < xx1 THEN SWAP xx2, xx1
 IF yy2 < yy1 THEN SWAP yy2, yy1
 IF xx2 < GFXxxLEFT OR xx1 > GFXxxRIGHT THEN EXIT SUB
 IF yy2 < GFXyyTOP OR yy1 > GFXyyBOTTOM THEN EXIT SUB
 xLEFT = xx1: xRIGHT = xx2: yTOP = yy1: yBOTTOM = yy2
 IF xLEFT < GFXxxLEFT THEN xLEFT = GFXxxLEFT
 IF xRIGHT > GFXxxRIGHT THEN xRIGHT = GFXxxRIGHT
 IF yTOP < GFXyyTOP THEN yTOP = GFXyyTOP
 IF yBOTTOM > GFXyyBOTTOM THEN yBOTTOM = GFXyyBOTTOM
 '
 IF SYS.blending THEN
  segBLN& = VARSEG(BLEND(0))
  segGFX& = 1 + VARSEG(GFX(0))
  yt& = segGFX& + (yTOP * 20)
  yb& = segGFX& + (yBOTTOM * 20)
  FOR y& = yt& TO yb& STEP 20
   DEF SEG = y&
   FOR x = xLEFT TO xRIGHT
    c = PEEK(x)
    DEF SEG = segBLN&
    IF c > SKINcolour THEN
     B = PEEK(BLN&(SKINcolour) + (c - SKINcolour))
    ELSE
     B = PEEK(BLN&(c) + (SKINcolour - c))
    END IF
    DEF SEG = y&
    POKE x, B
   NEXT
  NEXT
 ELSE
  LINE (xLEFT, yTOP)-(xRIGHT, yBOTTOM), SKINcolour, BF
 END IF
 '
END SUB

SUB DELsystem (seconds!) STATIC
 '
 IF delay& THEN
  FOR inc& = 1 TO (delay& * (seconds! * 18.6245)): NEXT
 ELSE
  DEF SEG = &H40
  DO: LOOP UNTIL PEEK(&H6C) <> PEEK(&H6C)
  t = PEEK(&H6C)
  DO
   FOR clc& = clc& TO clc& * 2: NEXT
  LOOP UNTIL t <> PEEK(&H6C)
  delay& = clc&
  i& = 1
  DO
   i& = i& * 2
   d& = clc& \ i&
   DO: LOOP UNTIL PEEK(&H6C) <> PEEK(&H6C)
   t = PEEK(&H6C)
   FOR inc& = 1 TO delay&: NEXT
   IF t <> PEEK(&H6C) THEN
    delay& = delay& - d&
   ELSE
    delay& = delay& + d&
   END IF
  LOOP UNTIL i& >= clc&
 END IF
 '
END SUB

FUNCTION FILlength& (file$)
 '
 FF = FREEFILE
 OPEN file$ FOR BINARY ACCESS READ AS FF
  FILlength& = LOF(FF) - 7
 CLOSE FF
 '
END FUNCTION

SUB GFXhandler
  '
  STATIC FRM, FPS$, REC!
  '
  '...START OF USER DEFINED MAP LEVELS...
  '
  MAPput TILES(), 1, "SOLID"
  '
  MAPput TILES(), 2, "TRANSPARENT"
  '
  IF SYS.blending THEN
   MAPput TILES(), 3, "BLEND"
  END IF
  '
  PLRput
  '
  MAPput TILES(), 4, "SOLID"
  '
  MAPput TILES(), 5, "TRANSPARENT"
  '
  IF SYS.blending THEN
   MAPput TILES(), 6, "BLEND"
  END IF
  '
  '...END OF USER DEFINED MAP LEVELS...
  '
  '
  'Frames Per Second odometer...
  '
  FRM = FRM + 1
  IF ABS(TIMER - REC!) >= 1 THEN FPS$ = "FPS:" + STR$(FRM): FRM = 0: REC! = TIMER
  PUTtext FONT(), FALSE, (GFXxxLEFT + 4), (GFXyyTOP + 4), 15, FPS$, "TRANSPARENT"
  '
  'Wait for Vertical trace...
  '
  IF SYS.vsync THEN WAIT &H3DA, 8: WAIT &H3DA, 8, 8
  '
  'Cameras panning points...
  '
  'LINE (PLR.panhXL, PLR.panvYT)-(PLR.panhXR, PLR.panvYB), 14, B
  '
  'Players sprite area...
  '
  'LINE (PLR.xx, (PLR.yy + PLR.Sink))-((PLR.xx + (PLR.wide - 1)), ((PLR.yy + (PLR.high - 1)) + PLR.Sink)), 15, B
  '
  'Player collision area...
  '
  'FOR x = 0 TO 8
  ' IF cpXX(x) OR cpYY(x) THEN PSET (cpXX(x), cpYY(x)), 16
  'NEXT
  '
END SUB

SUB GFXshow
 '
 DEF SEG
 POKE GFX(0), GFX(2): POKE GFX(1), GFX(3)
 PUT (0, 0), GFX(6), PSET
 POKE GFX(0), GFX(4): POKE GFX(1), GFX(5)
 '
END SUB

SUB KEYget
 '
 i = INP(&H60): IF i = 170 THEN REDIM BOARD(127): EXIT SUB
 IF (i AND &H80) THEN
  BOARD(i XOR &H80) = FALSE
 ELSE
  BOARD(i) = NOT FALSE
 END IF
 '
 DEF SEG = &H40: POKE &H1C, PEEK(&H1A)
 '
END SUB

SUB KEYhandler
  '
  PLR.walking = FALSE
  PLR.walkvY2 = NOT FALSE
  PLR.walkvY8 = NOT FALSE
  PLR.walkhX4 = NOT FALSE
  PLR.walkhX6 = NOT FALSE
  '
  IF BOARD(1) THEN  '[ESC]
   GOSUB CLRkeys
   MENhandler "System"
   GOSUB CLRkeys
  END IF
  '
  IF BOARD(80) THEN '[2]
   FOR lvl = 1 TO ENG.MAPlevels
    PLR.walkvY2 = PLR.walkvY2 AND Collide(lvl, 3).Walk AND Collide(lvl, 4).Walk
   NEXT
   IF SYS.collision THEN
    IF PLR.walkvY2 THEN MAPpan 2
   ELSE
    MAPpan 2
   END IF
   PLR.direction = 2
   PLR.walking = (NOT FALSE)
  END IF
  '
  IF BOARD(72) THEN '[8]
   FOR lvl = 1 TO ENG.MAPlevels
    PLR.walkvY8 = PLR.walkvY8 AND Collide(lvl, 1).Walk AND Collide(lvl, 2).Walk
   NEXT
   IF SYS.collision THEN
    IF PLR.walkvY8 THEN MAPpan 8
   ELSE
    MAPpan 8
   END IF
   PLR.direction = 8
   PLR.walking = (NOT FALSE)
  END IF
  '
  IF BOARD(75) THEN '[4]
   FOR lvl = 1 TO ENG.MAPlevels
    PLR.walkhX4 = PLR.walkhX4 AND Collide(lvl, 5).Walk AND Collide(lvl, 6).Walk
   NEXT
   IF SYS.collision THEN
    IF PLR.walkhX4 THEN
     MAPpan 4
     PLR.direction = 4
    ELSE
     IF BOARD(80) OR BOARD(72) THEN  ELSE PLR.direction = 4
    END IF
   ELSE
     MAPpan 4
     PLR.direction = 4
   END IF
   PLR.walking = (NOT FALSE)
   IF redirect THEN
    PLR.direction = redirect
    redirect = FALSE
    IF BOARD(80) OR BOARD(72) THEN  ELSE PLR.direction = 4
   END IF
  END IF
  '
  IF BOARD(77) THEN '[6]
   FOR lvl = 1 TO ENG.MAPlevels
    PLR.walkhX6 = PLR.walkhX6 AND Collide(lvl, 7).Walk AND Collide(lvl, 8).Walk
   NEXT
   IF SYS.collision THEN
    IF PLR.walkhX6 THEN
     MAPpan 6
     PLR.direction = 6
    ELSE
     IF BOARD(80) OR BOARD(72) THEN  ELSE PLR.direction = 6
    END IF
   ELSE
     MAPpan 6
     PLR.direction = 6
   END IF
   PLR.walking = (NOT FALSE)
   IF redirect THEN
    PLR.direction = redirect
    redirect = FALSE
    IF BOARD(80) OR BOARD(72) THEN  ELSE PLR.direction = 6
   END IF
  END IF
  '
  EXIT SUB
  '
CLRkeys:
 '
 DEF SEG = &H40
 KB = PEEK(&H1A)
 POKE KB, 0
 POKE KB + 1, 0
 POKE &H1C, KB
 REDIM BOARD(127)
 DELsystem 1 / 8
 '
 RETURN
 '
END SUB

SUB MAPcollision
 '
 cpXX(0) = (PLR.xx + PLR.colx5)
 cpYY(0) = (PLR.yy + PLR.coly5)
 '
 cpXX(1) = cpXX(0) + PLR.colX4
 cpYY(1) = cpYY(0) + PLR.colY8 + -PLR.pace
 cpXX(2) = cpXX(0) + PLR.colX6
 cpYY(2) = cpYY(0) + PLR.colY8 + -PLR.pace
 cpXX(3) = cpXX(0) + PLR.colX4
 cpYY(3) = cpYY(0) + PLR.colY2 + PLR.pace
 cpXX(4) = cpXX(0) + PLR.colX6
 cpYY(4) = cpYY(0) + PLR.colY2 + PLR.pace
 cpXX(5) = cpXX(0) + PLR.colX4 + -PLR.pace
 cpYY(5) = cpYY(0) + PLR.colY8
 cpXX(6) = cpXX(0) + PLR.colX4 + -PLR.pace
 cpYY(6) = cpYY(0) + PLR.colY2
 cpXX(7) = cpXX(0) + PLR.colX6 + PLR.pace
 cpYY(7) = cpYY(0) + PLR.colY8
 cpXX(8) = cpXX(0) + PLR.colX6 + PLR.pace
 cpYY(8) = cpYY(0) + PLR.colY2
 '
 FOR x = 0 TO 8
  cpXX = ((cpXX(x) - ENG.CAMzx) - ENG.TILhXL) \ ENG.TILwidth
  cpYY = ((cpYY(x) - ENG.CAMzy) - ENG.TILvYT) \ ENG.TILheight
  cpZZ = (cpYY * ENG.TILxx) + (cpXX + 1)
  FOR lvl = 1 TO ENG.MAPlevels
   Collide(lvl, x).Kind = TIL(MAP(lvl, cpZZ)).Kind
   Collide(lvl, x).Walk = TIL(MAP(lvl, cpZZ)).Walk
   Collide(lvl, x).Sink = TIL(MAP(lvl, cpZZ)).Sink
   Collide(lvl, x).Cycle = TIL(MAP(lvl, cpZZ)).Cycle
  NEXT
 NEXT
 '
END SUB

SUB MAPcycler
 '
 STATIC REC!
 '
 IF SYS.cycles THEN
  IF ABS(TIMER - REC!) >= ENG.MAPcycles THEN
   REC! = TIMER
   FOR lvl = 1 TO ENG.MAPlevels
    FOR x = LBOUND(MAP, 2) TO UBOUND(MAP, 2)
     IF TIL(MAP(lvl, x)).Cycle THEN MAP(lvl, x) = TIL(MAP(lvl, x)).Cycle
    NEXT
   NEXT
  END IF
 END IF
 '
END SUB

SUB MAPget (ARRAY(), xx, yy, LEVEL)
  '
 IF LEVEL THEN
  '
  DEF SEG = VARSEG(ARRAY(0))
  '
  MAPwidth = ARRAY(0) \ 8
  MAPheight& = ARRAY(1)
  MP& = 4 + (MAPwidth * MAPheight&)
  MF = LEVEL - 1
  MZ = (MAPwidth - ENG.TILxx)
  MB& = 4 + (MP& * MF) + (xx + (yy * MAPwidth))
  '
  FOR y = 1 TO ENG.TILyy
   FOR x = 1 TO ENG.TILxx
    t = t + 1
    MAP(LEVEL, t) = PEEK(MB&)
    MB& = MB& + 1
   NEXT
   MB& = MB& + MZ
  NEXT
  '
 END IF
 '
END SUB

SUB MAPhandler
 '
 STATIC recXX, recYY
 '
 IF ENG.MAPxx <> recXX OR ENG.MAPyy <> recYY THEN
  recXX = ENG.MAPxx: recYY = ENG.MAPyy
  FOR lvl = LBOUND(MAP, 1) TO UBOUND(MAP, 1)
   MAPget MAPS(), ENG.MAPxx, ENG.MAPyy, lvl
  NEXT
 END IF
 '
END SUB

SUB MAPpan (direction)
 '
 SELECT CASE direction
  '
 CASE 2
  '
  IF PLR.yy >= PLR.panvYB THEN
   IF ENG.MAPyy <= (ENG.MAPyymax + 1) THEN
    ENG.CAMzy = ENG.CAMzy - PLR.pace
    IF ENG.CAMzy < 0 THEN
     IF ENG.MAPyy = (ENG.MAPyymax + 1) THEN ENG.CAMzy = 0: GOTO 2
     ENG.CAMzy = ENG.CAMzy + ENG.TILheight
     ENG.MAPyy = ENG.MAPyy + 1
    END IF
   END IF
  ELSE
2  IF PLR.yy < PLR.maxvYB THEN PLR.yy = PLR.yy + PLR.pace
  END IF
  '
 CASE 8
  '
  IF PLR.yy <= PLR.panvYT THEN
   IF ENG.MAPyy >= 0 THEN
    ENG.CAMzy = ENG.CAMzy + PLR.pace
    IF ENG.CAMzy >= ENG.TILheight THEN
     ENG.CAMzy = ENG.CAMzy - ENG.TILheight
     ENG.MAPyy = ENG.MAPyy - 1
    END IF
   ELSE
    ENG.CAMzy = 0: GOTO 8
   END IF
  ELSE
8  IF PLR.yy > PLR.maxvYT THEN PLR.yy = PLR.yy - PLR.pace
  END IF
  '
 CASE 4
  '
  IF PLR.xx <= PLR.panhXL THEN
   IF ENG.MAPxx >= 0 THEN
    ENG.CAMzx = ENG.CAMzx + PLR.pace
    IF ENG.CAMzx >= ENG.TILwidth THEN
     ENG.CAMzx = ENG.CAMzx - ENG.TILwidth
     ENG.MAPxx = ENG.MAPxx - 1
    END IF
   ELSE
    ENG.CAMzx = 0: GOTO 4
   END IF
  ELSE
4  IF PLR.xx > PLR.maxhXL THEN PLR.xx = PLR.xx - PLR.pace ELSE redirect = PLR.direction
  END IF
  '

 CASE 6
  '
  IF PLR.xx >= PLR.panhXR THEN
   IF ENG.MAPxx <= (ENG.MAPxxmax + 1) THEN
    ENG.CAMzx = ENG.CAMzx - PLR.pace
    IF ENG.CAMzx < 0 THEN
     IF ENG.MAPxx = (ENG.MAPxxmax + 1) THEN ENG.CAMzx = 0: GOTO 6
     ENG.CAMzx = ENG.CAMzx + ENG.TILwidth
     ENG.MAPxx = ENG.MAPxx + 1
    END IF
   END IF
  ELSE
6  IF PLR.xx < PLR.maxhXR THEN PLR.xx = PLR.xx + PLR.pace ELSE redirect = PLR.direction
  END IF
  '
 END SELECT
 '
END SUB

SUB MAPput (ARRAY() AS INTEGER, LEVEL, skin$)
 '
 FOR y = (ENG.TILvYT + ENG.CAMzy) TO (ENG.TILvYB + ENG.CAMzy) STEP ENG.TILheight
  FOR x = (ENG.TILhXL + ENG.CAMzx) TO (ENG.TILhXR + ENG.CAMzx) STEP ENG.TILwidth
   m = m + 1
   PUTtile TILES(), x, y, MAP(LEVEL, m), skin$
  NEXT
 NEXT
 '
END SUB

SUB MENhandler (Menu$)
 '
 menudims = 2
 '
 DIM ROW(1 TO menudims)
 DIM LAST$(1 TO menudims)
 DIM x(1 TO menudims)
 DIM y(1 TO menudims)
 '
 FOR x = 1 TO menudims
  ROW(x) = 1
 NEXT
 '
 xx = GFXxxLEFT
 yy = GFXyyTOP
 '
loop1:
 '
 LEVEL = LEVEL + 1
 file$ = "buffer" + CHR$(LEVEL + 48) + ".tmp"
 DEF SEG = 1 + VARSEG(GFX(0)): BSAVE file$, 0, 64000
 '
Loop2:
 '
 LAST$(LEVEL) = Menu$
 SELECT CASE Menu$
  CASE "System"
    MENscript "menusys.scr", xx, yy, 4, 7, "BLEND"
 END SELECT
 '
 DO
  '
  GOSUB KBD
  '
  FONTcolour = 15
  GOSUB Cursor
  IF KB2 = 72 THEN 'UP
   FONTcolour = 7
   GOSUB Cursor
   ROW(LEVEL) = ROW(LEVEL) - 1
   IF ROW(LEVEL) < TEXTlbound THEN ROW(LEVEL) = TEXTubound
  END IF
  IF KB2 = 80 THEN 'DOWN
   FONTcolour = 7
   GOSUB Cursor
   ROW(LEVEL) = ROW(LEVEL) + 1
   IF ROW(LEVEL) > TEXTubound THEN ROW(LEVEL) = TEXTlbound
  END IF
  IF KB2 = 1 THEN '*** ESC ***
   IF LEVEL <= 1 THEN
    EXIT SUB
   ELSE
    FOR x = LEVEL TO menudims
     ROW(x) = 1
    NEXT
    LEVEL = LEVEL - 1
    file$ = "buffer" + CHR$(LEVEL + 48) + ".tmp"
    DEF SEG = 1 + VARSEG(GFX(0)): BLOAD file$, 0
    Menu$ = LAST$(LEVEL)
    xx = x(LEVEL)
    yy = y(LEVEL)
    GOTO Loop2
   END IF
  END IF
 LOOP UNTIL KB2 = 28 'ENTER
 '
 Menu$ = TEXT$(ROW(LEVEL))
 GOSUB NEWcords
 SELECT CASE Menu$
  '
  CASE "On"
   SELECT CASE LAST$(LEVEL)
    CASE "Vsync"
     SYS.vsync = (NOT FALSE)
     SCRhandler "vsyncon.scr", 1, 15, "BLEND"
    CASE "Collision"
     SYS.collision = (NOT FALSE)
     SCRhandler "collion.scr", 1, 15, "BLEND"
    CASE "Cycles"
     SYS.cycles = (NOT FALSE)
     SCRhandler "cycleon.scr", 1, 15, "BLEND"
    CASE "Blending"
     SYS.blending = (NOT FALSE)
     SCRhandler "blendon.scr", 1, 15, "BLEND"
   END SELECT
   '
  CASE "Off"
   SELECT CASE LAST$(LEVEL)
    CASE "Vsync"
     SYS.vsync = FALSE
     SCRhandler "vsyncoff.scr", 1, 15, "BLEND"
    CASE "Collision"
     SYS.collision = FALSE
     SCRhandler "collioff.scr", 1, 15, "BLEND"
    CASE "Cycles"
     SYS.cycles = FALSE
     SCRhandler "cycleoff.scr", 1, 15, "BLEND"
    CASE "Blending"
     SYS.blending = FALSE
     SCRhandler "blendoff.scr", 1, 15, "BLEND"
   END SELECT
   '
  CASE "Quit"
   KILL "buffer*.tmp"
   SCREEN 0: WIDTH 80: COLOR 7: CLS
   COLOR 1: LOCATE 2, 31: PRINT "";
   COLOR 9: PRINT " Quest-Kit ";
   COLOR 1: PRINT "۲"
   LOCATE 4, 35: PRINT "[Beta v1.1]"
   COLOR 7: LOCATE 25, 1: PRINT "(C)opyright 2004, "; : COLOR 2: PRINT "ElectroSoft Corp.";
   SLEEP
   COLOR 7
   CLS
   SYSTEM
  CASE ELSE
   MENscript "menuask.scr", xx, yy, 4, 7, "BLEND"
   GOTO loop1
 END SELECT
 '
 GFXshow
 DELsystem 1
 EXIT SUB
 '
'''
Cursor:
'''
 '
 length = LEN(TEXT$(ROW(LEVEL)))
 x1 = (xx + (FONTwidth \ 2)) - 1
 x2 = x1 + (length * FONTwidth)
 y1 = (yy + (FONTheight \ 2)) + ((ROW(LEVEL) - 1) * FONTheight) - 1
 y2 = y1 + (FONTheight)
 '
 SELECT CASE FONTcolour
  CASE 15
   FONTcolour = 7
  CASE 7
   FONTcolour = 8
 END SELECT
 '
 PUTtext FONT(), FALSE, (x1 + 2), (y1 + 1), FONTcolour, TEXT$(ROW(LEVEL)), "TRANSPARENT"
 '
 SELECT CASE FONTcolour
  CASE 7
   FONTcolour = 15
  CASE 8
   FONTcolour = 7
 END SELECT
 '
 PUTtext FONT(), FALSE, (x1 + 1), (y1 + 1), FONTcolour, TEXT$(ROW(LEVEL)), "TRANSPARENT"
 GFXshow
 DELsystem 1 / 32
 '
 RETURN
 '
'''
NEWcords:
'''
 '
 x(LEVEL) = xx
 y(LEVEL) = yy
 xx = xx + ((TEXTlength * FONTwidth) + FONTwidth)
 yy = yy + ((ROW(LEVEL) - 1) * FONTheight)
 '
 RETURN
 '
'''
KBD:
'''
 '
 DEF SEG = &H40
 KB = PEEK(&H1A)
 KB1 = PEEK(KB)
 KB2 = PEEK(KB + 1)
 POKE KB, 0
 POKE KB + 1, 0
 POKE &H1C, KB
 '
 RETURN
 '
END SUB

SUB MENscript (file$, x1, y1, SKINcolour, FONTcolour, skin$)
 '
 SCRread file$
 SCRshow x1, y1, SKINcolour, FONTcolour, skin$
 '
END SUB

SUB PALload (file$, BLEND$)
 '
 IF FILlength&(file$) THEN
  DEF SEG = VARSEG(PAL(0))
  BLOAD file$, 0
  OUT &H3C8, 0
  FOR x = 0 TO 255
   OUT &H3C9, PAL(x).Red
   OUT &H3C9, PAL(x).Grn
   OUT &H3C9, PAL(x).Blu
  NEXT
 END IF
 '
 IF FILlength&(BLEND$) THEN
  DEF SEG = VARSEG(BLEND(0))
  BLOAD BLEND$, 0
 END IF
 '
END SUB

SUB PLRput
  '
  STATIC FRM, REC!
  '
  FOR lvl = 1 TO ENG.MAPlevels
   Sink = Sink + Collide(lvl, 0).Sink
   PLR.Sink = Sink
  NEXT
  '
  IF PLR.Sink THEN
   REC = GFXyyBOTTOM
   GFXyyBOTTOM = PLR.yy + (PLR.high - 1)
  END IF
  '
  IF PLR.walking THEN
   IF ABS(TIMER - REC!) >= PLR.Cycle THEN FRM = FRM + 1: REC! = TIMER
   SELECT CASE FRM
    CASE 1
     add = 1
    CASE 2
     add = 0
    CASE 3
     add = 2
    CASE 4
     add = 0
     FRM = 0
   END SELECT
  ELSE
   IF ABS(TIMER - REC!) >= PLR.Cycle THEN add = 0
  END IF
  '
  SELECT CASE PLR.direction
   CASE 2
    PLR.frame = 4 + add
   CASE 4
    PLR.frame = 10 + add
   CASE 6
    PLR.frame = 7 + add
   CASE 8
    PLR.frame = 1 + add
  END SELECT
  '
  PUTtile PLAYER(), PLR.xx, (PLR.yy + PLR.Sink), PLR.frame, "TRANSPARENT"
  '
  IF PLR.Sink THEN
   GFXyyBOTTOM = REC
  END IF
  '
END SUB

SUB PUTcam (XXleft, YYtop, XXright, YYbottom)
 '
 GFXxxLEFT = XXleft
 GFXyyTOP = YYtop
 GFXxxRIGHT = XXright
 GFXyyBOTTOM = YYbottom
 '
 IF GFXxxLEFT < 0 THEN GFXxxLEFT = 0
 IF GFXxxRIGHT > 319 THEN GFXxxRIGHT = 319
 IF GFXyyTOP < 0 THEN GFXyyTOP = 0
 IF GFXyyBOTTOM > 199 THEN GFXyyBOTTOM = 199
 '
END SUB

SUB PUTload (ARRAY(), file$)
 '
 WORDS = ((FILlength&(file$) + 1) \ 2) - 1
 REDIM ARRAY(WORDS)
 DEF SEG = VARSEG(ARRAY(0))
 BLOAD file$, 0
 '
END SUB

SUB PUTtext (ARRAY(), XXcenter, XXleft, YYtop, colour, TEXT$, skin$)
 '
 FONTwidth = ARRAY(0) \ 8
 PUTcolour = -1 + colour
 FONTyy = YYtop
 '
 TL = LEN(TEXT$)
 '
 IF XXcenter THEN
  cx = (GFXxxLEFT + ((GFXxxRIGHT - GFXxxLEFT) + 1) \ 2)
  xx = cx - ((TL * FONTwidth) \ 2)
 ELSE
  xx = XXleft
 END IF
 '
 FOR x = 1 TO TL
  frame = (ASC(MID$(TEXT$, x, 1)) - 31)
  FONTxx = xx + ((x - 1) * FONTwidth)
  PUTtile ARRAY(), FONTxx, FONTyy, frame, skin$
 NEXT
 '
 PUTcolour = FALSE
 '
END SUB

SUB PUTtile (ARRAY(), XXleft, YYtop, frame, skin$)
'
 IF frame THEN
  '
  GFXseg& = 1 + VARSEG(GFX(0))
  TILESseg& = VARSEG(ARRAY(0))
  '
  TILESwidth = ARRAY(0) \ 8
  TILESheight& = ARRAY(1)
  '
  TP& = 4 + (TILESwidth * TILESheight&)
  '
  TH = ARRAY(1) - 1
  TW = TILESwidth - 1
  TF = frame - 1
  TL = XXleft + TW
  TT = YYtop + TH
  '
  IF XXleft < GFXxxLEFT THEN
   clip = NOT FALSE
   xl = GFXxxLEFT
   CLIPadd = GFXxxLEFT - XXleft
   IF CLIPadd > TW THEN EXIT SUB
   IF CLIPadd < 0 THEN CLIPadd = -CLIPadd
   CL = CLIPadd
  ELSE
   xl = XXleft
  END IF
  '
  IF TL > GFXxxRIGHT THEN
   clip = NOT FALSE
   xr = GFXxxRIGHT
   CLIPadd = TL - GFXxxRIGHT
   IF CLIPadd > TW THEN EXIT SUB
  ELSE
   xr = TL
  END IF
  '
  IF YYtop < GFXyyTOP THEN
   clip = NOT FALSE
   yt& = GFXseg& + (GFXyyTOP * 20)
   CT = GFXyyTOP - YYtop
   IF CT > TH THEN EXIT SUB
   IF CT < 0 THEN CT = -CT
   CT = CT * TILESwidth
  ELSE
   yt& = GFXseg& + (YYtop * 20)
  END IF
  '
  IF TT > GFXyyBOTTOM THEN
   clip = NOT FALSE
   yb& = GFXseg& + (GFXyyBOTTOM * 20)
   IF (TT - GFXyyBOTTOM) > TH THEN EXIT SUB
  ELSE
   yb& = GFXseg& + (TT * 20)
  END IF
  '
  IF TP& AND &H1 THEN
   TB& = 4 + TF + ((TP& * TF) + (CL + CT))
  ELSE
   TB& = 4 + ((TP& * TF) + (CL + CT))
  END IF
  '
  DIM c(xl TO xr)
  '
  SELECT CASE skin$
    '
   CASE "SOLID"
    '
    IF clip THEN
     FOR y& = yt& TO yb& STEP 20
      DEF SEG = TILESseg&
      FOR x = xl TO xr
       c(x) = PEEK(TB&)
       TB& = TB& + 1
      NEXT
      TB& = TB& + CLIPadd
      DEF SEG = y&
      FOR x = xl TO xr
       POKE x, c(x)
      NEXT
     NEXT
    ELSE
     PUT (XXleft, YYtop), ARRAY((TB& - 4) \ 2), PSET
    END IF
    '
   CASE "TRANSPARENT"
    '
    FOR y& = yt& TO yb& STEP 20
     DEF SEG = TILESseg&
     FOR x = xl TO xr
      c(x) = PEEK(TB&)
      TB& = TB& + 1
     NEXT
     TB& = TB& + CLIPadd
     DEF SEG = y&
     IF PUTcolour THEN
      FOR x = xl TO xr
       IF c(x) THEN POKE x, c(x) + PUTcolour
      NEXT
     ELSE
      FOR x = xl TO xr
       IF c(x) THEN POKE x, c(x)
      NEXT
     END IF
    NEXT
    '
   CASE "BLEND"
    '
    BLNseg = VARSEG(BLEND(0))
    '
    FOR y& = yt& TO yb& STEP 20
     DEF SEG = TILESseg&
     FOR x = xl TO xr
      c(x) = PEEK(TB&)
      TB& = TB& + 1
     NEXT
     TB& = TB& + CLIPadd
     DEF SEG = y&
     FOR x = xl TO xr
      IF c(x) THEN
       IF PUTcolour THEN c(x) = c(x) + PUTcolour
       v = PEEK(x)
       DEF SEG = BLNseg
       IF v > c(x) THEN
        B = PEEK(BLN&(c(x)) + (v - c(x)))
       ELSE
        B = PEEK(BLN&(v) + (c(x) - v))
       END IF
       DEF SEG = y&
       POKE x, B
      END IF
     NEXT
    NEXT
    '
  END SELECT
  '
 END IF
 '
END SUB

FUNCTION SCRcount (file$)
 '
 FF = FREEFILE
 OPEN file$ FOR INPUT AS #FF
  DO
   c = c + 1
   LINE INPUT #FF, d$
  LOOP UNTIL EOF(1)
 CLOSE #FF
 '
 SCRcount = c
 '
END FUNCTION

SUB SCRhandler (file$, SKINcolour, FONTcolour, skin$)
 '
 SCRread file$
 x1 = GFXxxLEFT + ((((GFXxxRIGHT - GFXxxLEFT) + 1) \ 2) - ((TEXTlength * FONTwidth) \ 2))
 y1 = GFXyyTOP + ((((GFXyyBOTTOM - GFXyyTOP) + 1) \ 2) - ((TEXTubound * FONTheight) \ 2))
 SCRshow x1, y1, SKINcolour, FONTcolour, skin$
 '
END SUB

SUB SCRread (file$)
 '
 REDIM TEXT$(1 TO SCRcount(file$))
 '
 FF = FREEFILE
 OPEN file$ FOR INPUT AS #FF
  DO
   c = c + 1
   LINE INPUT #FF, TEXT$(c)
  LOOP UNTIL EOF(1)
 CLOSE #FF
 '
 TEXTubound = UBOUND(TEXT$)
 TEXTlbound = LBOUND(TEXT$)
 FONTwidth = FONT(0) \ 8
 FONTheight = FONT(1)
 TEXTlength = 0
 '
 FOR x = TEXTlbound TO TEXTubound
  length = LEN(TEXT$(x))
  IF length > TEXTlength THEN TEXTlength = length
 NEXT
 '
END SUB

SUB SCRshow (x1, y1, SKINcolour, FONTcolour, skin$)
 '
 x2 = (x1 - 1) + ((FONTwidth * TEXTlength) + FONTwidth)
 y2 = (y1 - 1) + ((FONTheight * TEXTubound) + FONTheight)
 '
 SELECT CASE skin$
  CASE "SOLID"
   LINE (x1, y1)-(x2, y2), SKINcolour, BF
  CASE "BLEND"
   BOXblend x1, y1, x2, y2, SKINcolour
   LINE (x1, y1)-(x2, y2), SKINcolour, B
 END SELECT
 '
 ox1 = x1
 oy1 = y1
 '
 FOR y = 1 TO TEXTubound
  '
  SELECT CASE FONTcolour
   CASE 15
    FONTcolour = 7
   CASE 7
    FONTcolour = 8
  END SELECT
  '
  PUTtext FONT(), FALSE, ((ox1 + (FONTwidth \ 2)) + 1), (oy1 + (FONTheight \ 2)), FONTcolour, TEXT$(y), "TRANSPARENT"
  '
  SELECT CASE FONTcolour
   CASE 7
    FONTcolour = 15
   CASE 8
    FONTcolour = 7
  END SELECT
  '
  PUTtext FONT(), FALSE, (ox1 + (FONTwidth \ 2)), (oy1 + (FONTheight \ 2)), FONTcolour, TEXT$(y), "TRANSPARENT"
  '
  oy1 = oy1 + FONTheight
  '
 NEXT
 '
END SUB

